--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -4790,7 +4529,8 @@
 			aac_free_dmamap(acp);
 			if (bp->b_flags & (B_PHYS|B_PAGEIO))
 				bp_mapin(bp);
-			bcopy(&cap, bp->b_un.b_addr, min(bp->b_bcount, 8));
+			bcopy(&cap, bp->b_un.b_addr, 
+				bp->b_bcount < 8 ? bp->b_bcount : 8);
 			pkt->pkt_state |= STATE_XFERRED_DATA;
 		}
 		aac_soft_callback(softs, acp);
@@ -4805,14 +4545,14 @@
 				int cap_len = sizeof (struct scsi_capacity_16);
 
 				bzero(&cap16, cap_len);
-				cap16.sc_capacity = BE_64(dvp->size - 1);
+				cap16.sc_capacity = BE_64(dvp->size);
 				cap16.sc_lbasize = BE_32(AAC_SECTOR_SIZE);
 
 				aac_free_dmamap(acp);
 				if (bp->b_flags & (B_PHYS | B_PAGEIO))
 					bp_mapin(bp);
-				bcopy(&cap16, bp->b_un.b_addr,
-				    min(bp->b_bcount, cap_len));
+				bcopy(&cap16, bp->b_un.b_addr, 
+					bp->b_bcount < cap_len ? bp->b_bcount : cap_len);
 				pkt->pkt_state |= STATE_XFERRED_DATA;
 			}
 			aac_soft_callback(softs, acp);
@@ -4841,11 +4581,6 @@
 		acp->blkno = GETG0ADDR(cdbp);
 		goto do_io;
 
-	case SCMD_READ_G5: /* read_12 */
-	case SCMD_WRITE_G5: /* write_12 */
-		acp->blkno = GETG5ADDR(cdbp);
-		goto do_io;
-
 	case SCMD_READ_G1: /* read_10 */
 	case SCMD_WRITE_G1: /* write_10 */
 		acp->blkno = (uint32_t)GETG1ADDR(cdbp);
@@ -4899,14 +4634,6 @@
 		break;
 	}
 
-	case SCMD_START_STOP:
-		if (softs->support_opt2 & AAC_SUPPORTED_POWER_MANAGEMENT) {
-			acp->aac_cmd_fib = aac_cmd_fib_startstop;
-			acp->ac_comp = aac_startstop_complete;
-			rval = aac_do_io(softs, acp);
-			break;
-		}
-	/* FALLTHRU */
 	case SCMD_TEST_UNIT_READY:
 	case SCMD_REQUEST_SENSE:
 	case SCMD_FORMAT:
@@ -4937,6 +4664,14 @@
 		rval = TRAN_ACCEPT;
 		break;
 
+	case SCMD_START_STOP:
+		aac_free_dmamap(acp);
+		if (softs->aac_support_opt2 & AAC_SUPPORTED_POWER_MANAGEMENT) 
+			aac_startstop(softs, cdbp, dvp->cid);
+		aac_soft_callback(softs, acp);
+		rval = TRAN_ACCEPT;
+		break;
+
 	default: /* unknown command */
 		aac_unknown_scmd(softs, acp);
 		rval = TRAN_ACCEPT;
@@ -4965,13 +4700,11 @@
 	acp->timeout = acp->pkt->pkt_time;
 	if (pkt->pkt_flags & FLAG_NOINTR)
 		acp->flags |= AAC_CMD_NO_INTR;
-#ifdef DEBUG
-	acp->fib_flags = AACDB_FLAGS_FIB_SCMD;
-#endif
+	acp->cur_segment = 0;
 	pkt->pkt_reason = CMD_CMPLT;
 	pkt->pkt_state = 0;
 	pkt->pkt_statistics = 0;
-	*pkt->pkt_scbp = STATUS_GOOD; /* clear arq scsi_status */
+	*pkt->pkt_scbp = 0; /* clear arq scsi_status */
 
 	if (acp->flags & AAC_CMD_DMA_VALID) {
 		pkt->pkt_resid = acp->bcount;
@@ -4979,7 +4712,7 @@
 		if ((acp->flags & AAC_CMD_CONSISTENT) &&
 		    (acp->flags & AAC_CMD_BUF_WRITE))
 			if (aac_dma_sync_ac(acp) != AACOK) {
-				ddi_fm_service_impact(softs->devinfo_p,
+				aac_fm_service_impact(softs->devinfo_p,
 				    DDI_SERVICE_UNAFFECTED);
 				return (TRAN_BADPKT);
 			}
@@ -4989,31 +4722,19 @@
 
 	mutex_enter(&softs->io_lock);
 	AACDB_PRINT_SCMD(softs, acp);
-	if ((dvp->flags & (AAC_DFLAG_VALID | AAC_DFLAG_CONFIGURING)) &&
-	    !(softs->state & AAC_STATE_DEAD)) {
-		if (dvp->type == AAC_DEV_LD) {
-			if (ap->a_lun == 0)
-				rval = aac_tran_start_ld(softs, acp);
-			else
-				goto error;
-		} else {
+	if (dvp->valid && ap->a_lun == 0 && !(softs->state & AAC_STATE_DEAD)) {
+		if (dvp->type == AAC_DEV_LD)
+			rval = aac_tran_start_ld(softs, acp);
+		else if (acp->segment_cnt > 1)
+			rval = TRAN_BADPKT;
+		else
 			rval = aac_do_io(softs, acp);
-		}
 	} else {
-error:
-#ifdef DEBUG
-		if (!(softs->state & AAC_STATE_DEAD)) {
-			AACDB_PRINT_TRAN(softs,
-			    "Cannot send cmd to target t%dL%d: %s",
-			    ap->a_target, ap->a_lun,
-			    "target invalid");
-		} else {
-			AACDB_PRINT(softs, CE_WARN,
-			    "Cannot send cmd to target t%dL%d: %s",
-			    ap->a_target, ap->a_lun,
-			    "adapter dead");
-		}
-#endif
+		AACDB_PRINT(softs, CE_WARN,
+		    "Cannot send cmd to target t%dL%d: %s",
+		    ap->a_target, ap->a_lun,
+		    (softs->state & AAC_STATE_DEAD) ?
+		    "adapter dead" : "target invalid");
 		rval = TRAN_FATAL_ERROR;
 	}
 	mutex_exit(&softs->io_lock);
@@ -5038,9 +4759,9 @@
 
 	mutex_enter(&softs->io_lock);
 	dvp = AAC_DEV(softs, ap->a_target);
-	if (dvp == NULL || !AAC_DEV_IS_VALID(dvp)) {
+	if (dvp == NULL || !dvp->valid) {
 		mutex_exit(&softs->io_lock);
-		AACDB_PRINT_TRAN(softs, "Bad target t%dL%d to getcap",
+		AACDB_PRINT(softs, CE_WARN, "Bad target t%dL%d to getcap",
 		    ap->a_target, ap->a_lun);
 		return (-1);
 	}
@@ -5054,7 +4775,7 @@
 		rval = 1;
 		break;
 	case SCSI_CAP_DMA_MAX:
-		rval = softs->dma_max;
+		rval = softs->buf_dma_attr.dma_attr_maxxfer;
 		break;
 	default:
 		rval = -1;
@@ -5086,9 +4807,9 @@
 
 	mutex_enter(&softs->io_lock);
 	dvp = AAC_DEV(softs, ap->a_target);
-	if (dvp == NULL || !AAC_DEV_IS_VALID(dvp)) {
+	if (dvp == NULL || !dvp->valid) {
 		mutex_exit(&softs->io_lock);
-		AACDB_PRINT_TRAN(softs, "Bad target t%dL%d to setcap",
+		AACDB_PRINT(softs, CE_WARN, "Bad target t%dL%d to setcap",
 		    ap->a_target, ap->a_lun);
 		return (-1);
 	}
@@ -5146,16 +4867,20 @@
 			off_t off;
 			size_t len;
 
-			rval = ddi_dma_getwin(acp->buf_dma_handle, acp->cur_win,
-			    &off, &len, &acp->cookie, &acp->left_cookien);
+			rval = ddi_dma_getwin(acp->segments[0].buf_dma_handle, 
+				acp->cur_win, &off, &len,
+				&acp->segments[0].cookie, &acp->segments[0].left_cookien);
+			acp->segment_cnt = 1;
+			acp->left_cookien = acp->segments[0].left_cookien;
 			if (rval == DDI_SUCCESS)
 				goto get_dma_cookies;
 			AACDB_PRINT(softs, CE_WARN,
 			    "ddi_dma_getwin() fail %d", rval);
 			return (AACERR);
+		} else {
+			AACDB_PRINT(softs, CE_WARN, "Nothing to transfer");
+			return (AACERR);
 		}
-		AACDB_PRINT(softs, CE_WARN, "Nothing to transfer");
-		return (AACERR);
 	}
 
 	/* We need to transfer data, so we alloc DMA resources for this pkt */
@@ -5162,6 +4887,9 @@
 	if (bp && bp->b_bcount != 0 && !(acp->flags & AAC_CMD_DMA_VALID)) {
 		uint_t dma_flags = 0;
 		struct aac_sge *sge;
+		int repeat = 0;
+		uint_t i, j;
+		uint32_t offset;
 
 		/*
 		 * We will still use this point to fake some
@@ -5182,110 +4910,183 @@
 		if (flags & PKT_DMA_PARTIAL)
 			dma_flags |= DDI_DMA_PARTIAL;
 
-		/* Alloc buf dma handle */
-		if (!acp->buf_dma_handle) {
-			rval = ddi_dma_alloc_handle(softs->devinfo_p,
-			    &softs->buf_dma_attr, cb, arg,
-			    &acp->buf_dma_handle);
-			if (rval != DDI_SUCCESS) {
-				AACDB_PRINT(softs, CE_WARN,
-				    "Can't allocate DMA handle, errno=%d",
-				    rval);
-				goto error_out;
-			}
-		}
+		do {
+			/* Bind buf */
+			if (((uintptr_t)bp->b_un.b_addr & AAC_DMA_ALIGN_MASK) == 0
+				&& !repeat) {
+				/* Alloc buf dma handle */
+				if (!acp->segments[0].buf_dma_handle) {
+					rval = ddi_dma_alloc_handle(softs->devinfo_p,
+						&softs->buf_dma_attr, cb, arg,
+						&acp->segments[0].buf_dma_handle);
+					if (rval != DDI_SUCCESS) {
+						AACDB_PRINT(softs, CE_WARN,
+							"Can't allocate DMA handle, errno=%d",
+							rval);
+						goto error_out;
+					}
+				}
+				rval = ddi_dma_buf_bind_handle(acp->segments[0].buf_dma_handle,
+					bp, dma_flags, cb, arg, &acp->segments[0].cookie,
+					&acp->segments[0].left_cookien);
+				acp->segment_cnt = 1;
+				acp->left_cookien = acp->segments[0].left_cookien;
+			} else {
+				AACDB_PRINT_TRAN(softs,
+					"non-aligned buffer: addr=0x%p, cnt=%lu",
+					(void *)bp->b_un.b_addr, bp->b_bcount);
+				if (bp->b_flags & (B_PAGEIO|B_PHYS))
+					bp_mapin(bp);
 
-		/* Bind buf */
-		if (((uintptr_t)bp->b_un.b_addr & AAC_DMA_ALIGN_MASK) == 0) {
-			rval = ddi_dma_buf_bind_handle(acp->buf_dma_handle,
-			    bp, dma_flags, cb, arg, &acp->cookie,
-			    &acp->left_cookien);
-		} else {
-			size_t bufsz;
+				if (repeat) {
+					repeat = 0;
+					acp->segment_cnt = (bp->b_bcount - 1) /
+						softs->buf_dma_attr.dma_attr_maxxfer + 1;
+					if (acp->segment_cnt > AAC_MAXSEGMENTS) {
+						AACDB_PRINT(softs, CE_WARN,
+							"After DDI_DMA_TOOBIG: Too much segments!");
+						acp->segment_cnt = AAC_MAXSEGMENTS;
+						goto error_out;
+					}
 
-			AACDB_PRINT_TRAN(softs,
-			    "non-aligned buffer: addr=0x%p, cnt=%lu",
-			    (void *)bp->b_un.b_addr, bp->b_bcount);
-			if (bp->b_flags & (B_PAGEIO|B_PHYS))
-				bp_mapin(bp);
+					for (i = 0; i < acp->segment_cnt; ++i) {
+						rval = ddi_dma_alloc_handle(softs->devinfo_p,
+							&softs->buf_dma_attr, cb, arg,
+							&acp->segments[i].buf_dma_handle);
+						if (rval != DDI_SUCCESS) {
+							AACDB_PRINT(softs, CE_WARN,
+								"After DDI_DMA_TOOBIG: Can't allocate DMA handle, errno=%d",
+								rval);
+							goto error_out;
+						}
+						if ((i == acp->segment_cnt - 1) &&
+							(bp->b_bcount % softs->buf_dma_attr.dma_attr_maxxfer))
+							acp->segments[i].abp_size = bp->b_bcount % 
+								softs->buf_dma_attr.dma_attr_maxxfer;
+						else
+							acp->segments[i].abp_size = 
+								softs->buf_dma_attr.dma_attr_maxxfer;
+						rval = ddi_dma_mem_alloc(acp->segments[i].buf_dma_handle,
+							acp->segments[i].abp_size,
+							&aac_acc_attr, DDI_DMA_STREAMING,
+							cb, arg, &acp->segments[i].abp, 
+							&acp->segments[i].abp_real_size, 
+							&acp->segments[i].abh);
 
-			rval = ddi_dma_mem_alloc(acp->buf_dma_handle,
-			    AAC_ROUNDUP(bp->b_bcount, AAC_DMA_ALIGN),
-			    &softs->acc_attr, DDI_DMA_STREAMING,
-			    cb, arg, &acp->abp, &bufsz, &acp->abh);
+						if (rval != DDI_SUCCESS) {
+							AACDB_PRINT(softs, CE_NOTE,
+								"Cannot alloc DMA to non-aligned buf");
+							bioerr = 0;
+							goto error_out;
+						}
+					}
+				} else {
+					/* Alloc buf dma handle */
+					if (!acp->segments[0].buf_dma_handle) {
+						rval = ddi_dma_alloc_handle(softs->devinfo_p,
+							&softs->buf_dma_attr, cb, arg,
+							&acp->segments[0].buf_dma_handle);
+						if (rval != DDI_SUCCESS) {
+							AACDB_PRINT(softs, CE_WARN,
+								"Can't allocate DMA handle, errno=%d",
+								rval);
+							goto error_out;
+						}
+					}
+					rval = ddi_dma_mem_alloc(acp->segments[0].buf_dma_handle,
+						AAC_ROUNDUP(bp->b_bcount, AAC_DMA_ALIGN),
+						&aac_acc_attr, DDI_DMA_STREAMING,
+						cb, arg, &acp->segments[0].abp, 
+						&acp->segments[0].abp_real_size, 
+						&acp->segments[0].abh);
 
-			if (rval != DDI_SUCCESS) {
-				AACDB_PRINT(softs, CE_NOTE,
-				    "Cannot alloc DMA to non-aligned buf");
-				bioerr = 0;
-				goto error_out;
+					if (rval != DDI_SUCCESS) {
+						AACDB_PRINT(softs, CE_NOTE,
+							"Cannot alloc DMA to non-aligned buf");
+						bioerr = 0;
+						goto error_out;
+					}
+					acp->segment_cnt = 1;
+					acp->segments[0].abp_size = bp->b_bcount;
+				}
+
+				acp->left_cookien = 0;
+				for (i = 0, offset = 0; i < acp->segment_cnt; ++i) {
+					if (acp->flags & AAC_CMD_BUF_WRITE) {
+						ddi_rep_put8(acp->segments[i].abh,
+							(uint8_t *)bp->b_un.b_addr + offset,
+							(uint8_t *)acp->segments[i].abp, 
+							acp->segments[i].abp_size,
+							DDI_DEV_AUTOINCR);
+						offset += acp->segments[i].abp_size;
+					}
+
+					rval = ddi_dma_addr_bind_handle(acp->segments[i].buf_dma_handle,
+						NULL, acp->segments[i].abp, 
+						acp->segments[i].abp_real_size, dma_flags, cb, arg,
+						&acp->segments[i].cookie, &acp->segments[i].left_cookien);
+					if (rval != DDI_DMA_MAPPED)
+						break;
+
+					acp->left_cookien += acp->segments[i].left_cookien;
+				}
 			}
 
-			if (acp->flags & AAC_CMD_BUF_WRITE)
-				ddi_rep_put8(acp->abh,
-				    (uint8_t *)bp->b_un.b_addr,
-				    (uint8_t *)acp->abp, bp->b_bcount,
-				    DDI_DEV_AUTOINCR);
+			switch (rval) {
+			case DDI_DMA_PARTIAL_MAP:
+				if (ddi_dma_numwin(acp->segments[0].buf_dma_handle,
+					&acp->total_nwin) == DDI_FAILURE) {
+					AACDB_PRINT(softs, CE_WARN,
+						"Cannot get number of DMA windows");
+					bioerr = 0;
+					goto error_out;
+				}
+				AACDB_PRINT_TRAN(softs, "buf bind, %d seg(s)",
+					acp->left_cookien);
+				acp->cur_win = 0;
+				break;
 
-			rval = ddi_dma_addr_bind_handle(acp->buf_dma_handle,
-			    NULL, acp->abp, bufsz, dma_flags, cb, arg,
-			    &acp->cookie, &acp->left_cookien);
-		}
+			case DDI_DMA_MAPPED:
+				AACDB_PRINT_TRAN(softs, "buf bind, %d seg(s)",
+					acp->left_cookien);
+				acp->cur_win = 0;
+				acp->total_nwin = 1;
+				break;
 
-		switch (rval) {
-		case DDI_DMA_PARTIAL_MAP:
-			if (ddi_dma_numwin(acp->buf_dma_handle,
-			    &acp->total_nwin) == DDI_FAILURE) {
-				AACDB_PRINT(softs, CE_WARN,
-				    "Cannot get number of DMA windows");
+			case DDI_DMA_NORESOURCES:
 				bioerr = 0;
+				AACDB_PRINT(softs, CE_WARN,
+					"Cannot bind buf for DMA: DDI_DMA_NORESOURCES");
 				goto error_out;
+			case DDI_DMA_BADATTR:
+			case DDI_DMA_NOMAPPING:
+				bioerr = EFAULT;
+				AACDB_PRINT(softs, CE_WARN,
+					"Cannot bind buf for DMA: DDI_DMA_NOMAPPING");
+				goto error_out;
+			case DDI_DMA_TOOBIG:
+				if (bp->b_bcount > softs->buf_dma_attr.dma_attr_maxxfer &&
+					acp->segment_cnt == 1) {
+					repeat = 1;
+					break;
+				} else {
+					bioerr = EINVAL;
+					AACDB_PRINT(softs, CE_WARN,
+						"Cannot bind buf for DMA: DDI_DMA_TOOBIG(%d) - returning EINVAL",
+						bp->b_bcount);
+					goto error_out;
+				}
+			default:
+				bioerr = EINVAL;
+				AACDB_PRINT(softs, CE_WARN,
+					"Cannot bind buf for DMA: %d", rval);
+				goto error_out;
 			}
-			AACDB_PRINT_TRAN(softs, "buf bind, %d seg(s)",
-			    acp->left_cookien);
-			acp->cur_win = 0;
-			break;
-
-		case DDI_DMA_MAPPED:
-			AACDB_PRINT_TRAN(softs, "buf bind, %d seg(s)",
-			    acp->left_cookien);
-			acp->cur_win = 0;
-			acp->total_nwin = 1;
-			break;
-
-		case DDI_DMA_NORESOURCES:
-			bioerr = 0;
-			AACDB_PRINT(softs, CE_WARN,
-			    "Cannot bind buf for DMA: DDI_DMA_NORESOURCES");
-			goto error_out;
-		case DDI_DMA_BADATTR:
-		case DDI_DMA_NOMAPPING:
-			bioerr = EFAULT;
-			AACDB_PRINT(softs, CE_WARN,
-			    "Cannot bind buf for DMA: DDI_DMA_NOMAPPING");
-			goto error_out;
-		case DDI_DMA_TOOBIG:
-			bioerr = EINVAL;
-			AACDB_PRINT(softs, CE_WARN,
-			    "Cannot bind buf for DMA: DDI_DMA_TOOBIG(%d)",
-			    bp->b_bcount);
-			goto error_out;
-		default:
-			bioerr = EINVAL;
-			AACDB_PRINT(softs, CE_WARN,
-			    "Cannot bind buf for DMA: %d", rval);
-			goto error_out;
-		}
+		} while (repeat);
 		acp->flags |= AAC_CMD_DMA_VALID;
 
 get_dma_cookies:
 		ASSERT(acp->left_cookien > 0);
-		if (acp->left_cookien > softs->aac_sg_tablesize) {
-			AACDB_PRINT(softs, CE_NOTE, "large cookiec received %d",
-			    acp->left_cookien);
-			bioerr = EINVAL;
-			goto error_out;
-		}
 		if (oldcookiec != acp->left_cookien && acp->sgt != NULL) {
 			kmem_free(acp->sgt, sizeof (struct aac_sge) * \
 			    oldcookiec);
@@ -5303,16 +5104,25 @@
 		}
 
 		sge = &acp->sgt[0];
-		sge->bcount = acp->cookie.dmac_size;
-		sge->addr.ad64.lo = AAC_LS32(acp->cookie.dmac_laddress);
-		sge->addr.ad64.hi = AAC_MS32(acp->cookie.dmac_laddress);
-		acp->bcount = acp->cookie.dmac_size;
-		for (sge++; sge < &acp->sgt[acp->left_cookien]; sge++) {
-			ddi_dma_nextcookie(acp->buf_dma_handle, &acp->cookie);
-			sge->bcount = acp->cookie.dmac_size;
-			sge->addr.ad64.lo = AAC_LS32(acp->cookie.dmac_laddress);
-			sge->addr.ad64.hi = AAC_MS32(acp->cookie.dmac_laddress);
-			acp->bcount += acp->cookie.dmac_size;
+		acp->bcount = 0;
+		for (i = 0; i < acp->segment_cnt; ++i) {
+			acp->segments[i].sgt = sge;
+			if (acp->segments[i].left_cookien > softs->aac_sg_tablesize) {
+				AACDB_PRINT(softs, CE_NOTE, "large cookiec received %d",
+					acp->segments[i].left_cookien);
+				bioerr = EINVAL;
+				goto error_out;
+			}
+			for (j = 0; j < acp->segments[i].left_cookien; ++j) {
+				if (j > 0)
+					ddi_dma_nextcookie(acp->segments[i].buf_dma_handle, 
+						&acp->segments[i].cookie);
+				sge->bcount = acp->segments[i].cookie.dmac_size;
+				sge->addr.ad64.lo = AAC_LS32(acp->segments[i].cookie.dmac_laddress);
+				sge->addr.ad64.hi = AAC_MS32(acp->segments[i].cookie.dmac_laddress);
+				acp->bcount += acp->segments[i].cookie.dmac_size;
+				sge++;
+			}
 		}
 
 		/*
@@ -5320,7 +5130,8 @@
 		 * dma_attr_maxxfer attribute. So we have to ensure
 		 * it by ourself.
 		 */
-		if (acp->bcount > softs->buf_dma_attr.dma_attr_maxxfer) {
+		if (acp->segment_cnt == 1 &&
+			acp->bcount > softs->buf_dma_attr.dma_attr_maxxfer) {
 			AACDB_PRINT(softs, CE_NOTE,
 			    "large xfer size received %d\n", acp->bcount);
 			bioerr = EINVAL;
@@ -5328,25 +5139,16 @@
 		}
 
 		acp->total_xfer += acp->bcount;
-
 		if (acp->pkt) {
 			/* Return remaining byte count */
-			if (acp->total_xfer <= bp->b_bcount) {
-				acp->pkt->pkt_resid = bp->b_bcount - \
-				    acp->total_xfer;
-			} else {
-				/*
-				 * Allocated DMA size is greater than the buf
-				 * size of bp. This is caused by devices like
-				 * tape. we have extra bytes allocated, but
-				 * the packet residual has to stay correct.
-				 */
-				acp->pkt->pkt_resid = 0;
-			}
+			acp->pkt->pkt_resid = bp->b_bcount - acp->total_xfer;
+
 			AACDB_PRINT_TRAN(softs,
 			    "bp=0x%p, xfered=%d/%d, resid=%d",
 			    (void *)bp->b_un.b_addr, (int)acp->total_xfer,
 			    (int)bp->b_bcount, (int)acp->pkt->pkt_resid);
+
+			ASSERT(acp->pkt->pkt_resid >= 0);
 		}
 	}
 	return (AACOK);
@@ -5418,7 +5220,7 @@
 	DBCALLED(NULL, 2);
 
 	if (aac_dma_sync_ac(acp) != AACOK)
-		ddi_fm_service_impact(
+		aac_fm_service_impact(
 		    (AAC_TRAN2SOFTS(ap->a_hba_tran))->devinfo_p,
 		    DDI_SERVICE_UNAFFECTED);
 }
@@ -5529,6 +5331,9 @@
 	hba_tran->tran_quiesce = aac_tran_quiesce;
 	hba_tran->tran_unquiesce = aac_tran_unquiesce;
 	hba_tran->tran_bus_config = aac_tran_bus_config;
+#if 0
+	hba_tran->tran_interconnect_type = INTERCONNECT_PARALLEL;
+#endif
 	rval = scsi_hba_attach_setup(softs->devinfo_p, &softs->buf_dma_attr,
 	    hba_tran, 0);
 	if (rval != DDI_SUCCESS) {
@@ -5549,10 +5354,9 @@
  * Init FIB header
  */
 static void
-aac_cmd_fib_header(struct aac_softstate *softs, struct aac_cmd *acp,
-    uint16_t cmd)
+aac_cmd_fib_header(struct aac_softstate *softs, struct aac_slot *slotp,
+    uint16_t cmd, uint16_t fib_size)
 {
-	struct aac_slot *slotp = acp->slotp;
 	ddi_acc_handle_t acc = slotp->fib_acc_handle;
 	struct aac_fib *fibp = slotp->fibp;
 	uint32_t xfer_state;
@@ -5561,26 +5365,162 @@
 	    AAC_FIBSTATE_HOSTOWNED |
 	    AAC_FIBSTATE_INITIALISED |
 	    AAC_FIBSTATE_EMPTY |
-	    AAC_FIBSTATE_FAST_RESPONSE | /* enable fast io */
 	    AAC_FIBSTATE_FROMHOST |
 	    AAC_FIBSTATE_REXPECTED |
 	    AAC_FIBSTATE_NORM;
+	if (slotp->acp && !(slotp->acp->flags & AAC_CMD_SYNC)) {
+		xfer_state |=
+		    AAC_FIBSTATE_ASYNC |
+		    AAC_FIBSTATE_FAST_RESPONSE /* enable fast io */;
+		ddi_put16(acc, &fibp->Header.SenderSize,
+		    softs->aac_max_fib_size);
+	} else {
+		ddi_put16(acc, &fibp->Header.SenderSize, AAC_FIB_SIZE);
+	}
 
-	if (!(acp->flags & AAC_CMD_SYNC))
-		xfer_state |= AAC_FIBSTATE_ASYNC;
-
 	ddi_put32(acc, &fibp->Header.XferState, xfer_state);
 	ddi_put16(acc, &fibp->Header.Command, cmd);
 	ddi_put8(acc, &fibp->Header.StructType, AAC_FIBTYPE_TFIB);
-	ddi_put8(acc, &fibp->Header.Flags, 0); /* don't care */
-	ddi_put16(acc, &fibp->Header.Size, acp->fib_size);
-	ddi_put16(acc, &fibp->Header.SenderSize, softs->aac_max_fib_size);
+	ddi_put8(acc, &fibp->Header.Unused, 0); /* don't care */
+	ddi_put16(acc, &fibp->Header.Size, fib_size);
 	ddi_put32(acc, &fibp->Header.SenderFibAddress, (slotp->index << 2));
-	ddi_put32(acc, &fibp->Header.ReceiverFibAddress, slotp->fib_phyaddr);
-	ddi_put32(acc, &fibp->Header.SenderData, 0); /* don't care */
+	ddi_put32(acc, &fibp->Header.a.ReceiverFibAddress, slotp->fib_phyaddr);
+	ddi_put32(acc, &fibp->Header.Handle, slotp->index + 1); 
 }
 
 /*
+ * Init FIB for raw IO2 command
+ */
+static void
+aac_cmd_fib_rawio2(struct aac_softstate *softs, struct aac_cmd *acp)
+{
+	ddi_acc_handle_t acc = acp->slotp->fib_acc_handle;
+	struct aac_raw_io2 *io = (struct aac_raw_io2 *)&acp->slotp->fibp->data[0];
+	struct aac_sge_ieee1212 *sgp;
+	struct aac_sge *sge = &acp->sgt[0];
+	uint_t i, left_cookien, conformable;
+	uint32_t min_size, cur_size, nom_size;
+	uint16_t flags;
+
+	if (acp->segment_cnt > 1) {
+		uint_t idx = acp->cur_segment;
+		left_cookien = acp->segments[idx].left_cookien;
+		acp->bcount = acp->segments[idx].abp_size;
+		sge = acp->segments[idx].sgt;
+		if (idx > 0) 
+			acp->blkno += acp->segments[idx-1].abp_size / AAC_BLK_SIZE;
+	} else
+		left_cookien = acp->left_cookien;
+
+	ddi_put32(acc, &io->strtBlkLow, AAC_LS32(acp->blkno));
+	ddi_put32(acc, &io->strtBlkHigh, AAC_MS32(acp->blkno));
+	ddi_put32(acc, &io->byteCnt, acp->bcount);
+	ddi_put16(acc, &io->ldNum,
+	    ((struct aac_container *)acp->dvp)->cid);
+	flags = (acp->flags & AAC_CMD_BUF_READ) ? 
+		RIO2_IO_TYPE_READ : RIO2_IO_TYPE_WRITE;
+	flags |= RIO2_SG_FORMAT_IEEE1212;
+
+	/* Fill SG table */
+	for (i = 0, sgp = &io->sge[0]; i < left_cookien; i++, sge++, sgp++) {
+		ddi_put32(acc, &sgp->addrLow, sge->addr.ad64.lo);
+		ddi_put32(acc, &sgp->addrHigh, sge->addr.ad64.hi);
+		ddi_put32(acc, &sgp->length, sge->bcount);
+		ddi_put32(acc, &sgp->flags, 0L);
+		cur_size = sge->bcount;
+		if (i == 0) {
+			conformable = 1;
+			ddi_put32(acc, &io->sgeFirstSize, cur_size);
+		} else if (i == 1) {
+			nom_size = cur_size;
+			ddi_put32(acc, &io->sgeNominalSize, nom_size);
+			min_size = cur_size;
+		} else if ((i+1) < left_cookien && cur_size != nom_size) {
+			conformable = 0;
+			if (cur_size < min_size)
+				min_size = cur_size;
+		}
+	}
+
+	/* not conformable: evaluate required sg elements */
+	if (!conformable) {
+		uint_t j, err_found, left_cookien_new = left_cookien;
+		for (i = min_size / AAC_PAGE_SIZE; i >= 1; --i) {
+			err_found = 0;
+			left_cookien_new = 2;
+			for (j = 1; j < left_cookien - 1; ++j) {
+				if (ddi_get32(acc, &io->sge[j].length) % (i*AAC_PAGE_SIZE)) {
+					err_found = 1;
+					break;
+				}
+				left_cookien_new += (ddi_get32(acc, &io->sge[j].length) / (i*AAC_PAGE_SIZE));
+			}
+			if (!err_found)
+				break;
+		}
+		if (i > 0 && left_cookien_new <= softs->aac_sg_tablesize && 
+			!softs->no_sgl_conv)
+			left_cookien = aac_convert_sgraw2(softs, 
+				acp, i, left_cookien, left_cookien_new, &flags);
+	} else {
+		flags |= RIO2_SGL_CONFORMANT;
+	}
+	ddi_put16(acc, &io->flags, flags);
+	ddi_put8(acc, &io->sgeCnt, left_cookien);
+
+	/* Calculate FIB size */
+	acp->fib_size = sizeof (struct aac_fib_header) + \
+	    sizeof (struct aac_raw_io2) + (left_cookien - 1) * \
+	    sizeof (struct aac_sge_ieee1212);
+
+	aac_cmd_fib_header(softs, acp->slotp, RawIo2, acp->fib_size);
+}
+
+
+static uint_t 
+aac_convert_sgraw2(struct aac_softstate *softs, struct aac_cmd *acp,
+				   uint_t pages, uint_t left_cookien, uint_t left_cookien_new,
+				   uint16_t *flags)
+{
+	ddi_acc_handle_t acc = acp->slotp->fib_acc_handle;
+	struct aac_raw_io2 *io = (struct aac_raw_io2 *)&acp->slotp->fibp->data[0];
+	struct aac_sge_ieee1212 *sge;
+	uint_t i, j, pos;
+	uint32_t addr_low_new, addr_low;
+
+	sge = kmem_alloc(left_cookien_new * sizeof(struct aac_sge_ieee1212), 
+					 KM_NOSLEEP);
+	if (sge == NULL)
+		return left_cookien;
+
+	for (i = 1, pos = 1; i < left_cookien-1; ++i) {
+		for (j = 0; j < ddi_get32(acc, &io->sge[i].length) / (pages * AAC_PAGE_SIZE); ++j) {
+			addr_low = ddi_get32(acc, &io->sge[i].addrLow);
+			addr_low_new = addr_low + j * pages * AAC_PAGE_SIZE;
+			sge[pos].addrLow = addr_low_new;
+			sge[pos].addrHigh = ddi_get32(acc, &io->sge[i].addrHigh);
+			if (addr_low_new < addr_low)
+				sge[pos].addrHigh++;
+			sge[pos].length = pages * AAC_PAGE_SIZE;
+			sge[pos].flags = 0;
+			pos++;
+		}
+	}
+	sge[pos].addrLow = ddi_get32(acc, &io->sge[left_cookien-1].addrLow);
+	sge[pos].addrHigh = ddi_get32(acc, &io->sge[left_cookien-1].addrHigh);
+	sge[pos].length = ddi_get32(acc, &io->sge[left_cookien-1].length);
+	sge[pos].flags = 0;
+	ddi_rep_put8(acc, (uint8_t *)&sge[1], 
+		(uint8_t *)&io->sge[1], (left_cookien_new-1) *
+		sizeof(struct aac_sge_ieee1212), DDI_DEV_AUTOINCR);
+
+	kmem_free(sge, left_cookien_new * sizeof(struct aac_sge_ieee1212));
+	*flags |= RIO2_SGL_CONFORMANT;
+	ddi_put32(acc, &io->sgeNominalSize, pages * AAC_PAGE_SIZE);
+	return left_cookien_new;
+}
+
+/*
  * Init FIB for raw IO command
  */
 static void
@@ -5589,14 +5529,25 @@
 	ddi_acc_handle_t acc = acp->slotp->fib_acc_handle;
 	struct aac_raw_io *io = (struct aac_raw_io *)&acp->slotp->fibp->data[0];
 	struct aac_sg_entryraw *sgp;
-	struct aac_sge *sge;
+	struct aac_sge *sge = &acp->sgt[0];
+	uint_t i, left_cookien;
 
+	if (acp->segment_cnt > 1) {
+		uint_t idx = acp->cur_segment;
+		left_cookien = acp->segments[idx].left_cookien;
+		acp->bcount = acp->segments[idx].abp_size;
+		sge = acp->segments[idx].sgt;
+		if (idx > 0) 
+			acp->blkno += acp->segments[idx-1].abp_size / AAC_BLK_SIZE;
+	} else
+		left_cookien = acp->left_cookien;
+
 	/* Calculate FIB size */
 	acp->fib_size = sizeof (struct aac_fib_header) + \
-	    sizeof (struct aac_raw_io) + (acp->left_cookien - 1) * \
+	    sizeof (struct aac_raw_io) + (left_cookien - 1) * \
 	    sizeof (struct aac_sg_entryraw);
 
-	aac_cmd_fib_header(softs, acp, RawIo);
+	aac_cmd_fib_header(softs, acp->slotp, RawIo, acp->fib_size);
 
 	ddi_put16(acc, &io->Flags, (acp->flags & AAC_CMD_BUF_READ) ? 1 : 0);
 	ddi_put16(acc, &io->BpTotal, 0);
@@ -5608,11 +5559,11 @@
 	    ((struct aac_container *)acp->dvp)->cid);
 
 	/* Fill SG table */
-	ddi_put32(acc, &io->SgMapRaw.SgCount, acp->left_cookien);
+	ddi_put32(acc, &io->SgMapRaw.SgCount, left_cookien);
 	ddi_put32(acc, &io->ByteCount, acp->bcount);
 
-	for (sge = &acp->sgt[0], sgp = &io->SgMapRaw.SgEntryRaw[0];
-	    sge < &acp->sgt[acp->left_cookien]; sge++, sgp++) {
+	for (i = 0, sgp = &io->SgMapRaw.SgEntryRaw[0]; 
+		i < left_cookien; i++, sge++, sgp++) {
 		ddi_put32(acc, AAC_LO32(&sgp->SgAddress), sge->addr.ad64.lo);
 		ddi_put32(acc, AAC_HI32(&sgp->SgAddress), sge->addr.ad64.hi);
 		ddi_put32(acc, &sgp->SgByteCount, sge->bcount);
@@ -5630,13 +5581,25 @@
 	struct aac_blockread64 *br = (struct aac_blockread64 *) \
 	    &acp->slotp->fibp->data[0];
 	struct aac_sg_entry64 *sgp;
-	struct aac_sge *sge;
+	struct aac_sge *sge = &acp->sgt[0];
+	uint_t i, left_cookien;
 
+	if (acp->segment_cnt > 1) {
+		uint_t idx = acp->cur_segment;
+		left_cookien = acp->segments[idx].left_cookien;
+		acp->bcount = acp->segments[idx].abp_size;
+		sge = acp->segments[idx].sgt;
+		if (idx > 0) 
+			acp->blkno += acp->segments[idx-1].abp_size / AAC_BLK_SIZE;
+	} else
+		left_cookien = acp->left_cookien;
+
 	acp->fib_size = sizeof (struct aac_fib_header) + \
-	    sizeof (struct aac_blockread64) + (acp->left_cookien - 1) * \
+	    sizeof (struct aac_blockread64) + (left_cookien - 1) * \
 	    sizeof (struct aac_sg_entry64);
 
-	aac_cmd_fib_header(softs, acp, ContainerCommand64);
+	aac_cmd_fib_header(softs, acp->slotp, ContainerCommand64,
+	    acp->fib_size);
 
 	/*
 	 * The definitions for aac_blockread64 and aac_blockwrite64
@@ -5651,11 +5614,11 @@
 	ddi_put16(acc, &br->Flags, 0);
 
 	/* Fill SG table */
-	ddi_put32(acc, &br->SgMap64.SgCount, acp->left_cookien);
+	ddi_put32(acc, &br->SgMap64.SgCount, left_cookien);
 	ddi_put16(acc, &br->SectorCount, acp->bcount / AAC_BLK_SIZE);
 
-	for (sge = &acp->sgt[0], sgp = &br->SgMap64.SgEntry64[0];
-	    sge < &acp->sgt[acp->left_cookien]; sge++, sgp++) {
+	for (i = 0, sgp = &br->SgMap64.SgEntry64[0];
+	    i < left_cookien; i++, sge++, sgp++) {
 		ddi_put32(acc, AAC_LO32(&sgp->SgAddress), sge->addr.ad64.lo);
 		ddi_put32(acc, AAC_HI32(&sgp->SgAddress), sge->addr.ad64.hi);
 		ddi_put32(acc, &sgp->SgByteCount, sge->bcount);
@@ -5671,28 +5634,39 @@
 	    &acp->slotp->fibp->data[0];
 	struct aac_sg_entry *sgp;
 	struct aac_sge *sge = &acp->sgt[0];
+	uint_t i, left_cookien;
 
+	if (acp->segment_cnt > 1) {
+		uint_t idx = acp->cur_segment;
+		left_cookien = acp->segments[idx].left_cookien;
+		acp->bcount = acp->segments[idx].abp_size;
+		sge = acp->segments[idx].sgt;
+		if (idx > 0) 
+			acp->blkno += acp->segments[idx-1].abp_size / AAC_BLK_SIZE;
+	} else
+		left_cookien = acp->left_cookien;
+
 	if (acp->flags & AAC_CMD_BUF_READ) {
 		acp->fib_size = sizeof (struct aac_fib_header) + \
-		    sizeof (struct aac_blockread) + (acp->left_cookien - 1) * \
+		    sizeof (struct aac_blockread) + (left_cookien - 1) * \
 		    sizeof (struct aac_sg_entry);
 
 		ddi_put32(acc, &br->Command, VM_CtBlockRead);
-		ddi_put32(acc, &br->SgMap.SgCount, acp->left_cookien);
+		ddi_put32(acc, &br->SgMap.SgCount, left_cookien);
 		sgp = &br->SgMap.SgEntry[0];
 	} else {
 		struct aac_blockwrite *bw = (struct aac_blockwrite *)br;
 
 		acp->fib_size = sizeof (struct aac_fib_header) + \
-		    sizeof (struct aac_blockwrite) + (acp->left_cookien - 1) * \
+		    sizeof (struct aac_blockwrite) + (left_cookien - 1) * \
 		    sizeof (struct aac_sg_entry);
 
 		ddi_put32(acc, &bw->Command, VM_CtBlockWrite);
 		ddi_put32(acc, &bw->Stable, CUNSTABLE);
-		ddi_put32(acc, &bw->SgMap.SgCount, acp->left_cookien);
+		ddi_put32(acc, &bw->SgMap.SgCount, left_cookien);
 		sgp = &bw->SgMap.SgEntry[0];
 	}
-	aac_cmd_fib_header(softs, acp, ContainerCommand);
+	aac_cmd_fib_header(softs, acp->slotp, ContainerCommand, acp->fib_size);
 
 	/*
 	 * aac_blockread and aac_blockwrite have the similar
@@ -5704,8 +5678,7 @@
 	ddi_put32(acc, &br->ByteCount, acp->bcount);
 
 	/* Fill SG table */
-	for (sge = &acp->sgt[0];
-	    sge < &acp->sgt[acp->left_cookien]; sge++, sgp++) {
+	for (i = 0; i < left_cookien; i++, sge++, sgp++) {
 		ddi_put32(acc, &sgp->SgAddress, sge->addr.ad32);
 		ddi_put32(acc, &sgp->SgByteCount, sge->bcount);
 	}
@@ -5722,20 +5695,23 @@
 	ddi_rep_put8(acc, (uint8_t *)acp->fibp, (uint8_t *)fibp,
 	    acp->fib_size,   /* only copy data of needed length */
 	    DDI_DEV_AUTOINCR);
-	ddi_put32(acc, &fibp->Header.ReceiverFibAddress, slotp->fib_phyaddr);
+	ddi_put32(acc, &fibp->Header.a.ReceiverFibAddress,slotp->fib_phyaddr);
 	ddi_put32(acc, &fibp->Header.SenderFibAddress, slotp->index << 2);
+	ddi_put32(acc, &fibp->Header.Handle, slotp->index + 1);
 }
 
 static void
 aac_cmd_fib_sync(struct aac_softstate *softs, struct aac_cmd *acp)
 {
-	ddi_acc_handle_t acc = acp->slotp->fib_acc_handle;
+	struct aac_slot *slotp = acp->slotp;
+	ddi_acc_handle_t acc = slotp->fib_acc_handle;
 	struct aac_synchronize_command *sync =
-	    (struct aac_synchronize_command *)&acp->slotp->fibp->data[0];
+	    (struct aac_synchronize_command *)&slotp->fibp->data[0];
 
-	acp->fib_size = AAC_FIB_SIZEOF(struct aac_synchronize_command);
+	acp->fib_size = sizeof (struct aac_fib_header) + \
+	    sizeof (struct aac_synchronize_command);
 
-	aac_cmd_fib_header(softs, acp, ContainerCommand);
+	aac_cmd_fib_header(softs, slotp, ContainerCommand, acp->fib_size);
 	ddi_put32(acc, &sync->Command, VM_ContainerConfig);
 	ddi_put32(acc, &sync->Type, (uint32_t)CT_FLUSH_CACHE);
 	ddi_put32(acc, &sync->Cid, ((struct aac_container *)acp->dvp)->cid);
